/*
 * Copyright (c) 2000 Greg Haerr <greg@censoft.com>
 *
 * Nano-X Client utility routines
 *
 * These routines are Gr* functionality without requiring new API entry points.
 */
#include <stdio.h>
#include <stdlib.h>
#define MWINCLUDECOLORS
#include "nano-X.h"

/*
 * Create new window with passed style, title and location.
 */
GR_WINDOW_ID
GrNewWindowEx(GR_WM_PROPS props, GR_CHAR *title, GR_WINDOW_ID parent,
	GR_COORD x, GR_COORD y, GR_SIZE width, GR_SIZE height,
	GR_COLOR background)
{
	GR_WINDOW_ID		wid;
	GR_WM_PROPS		newprops;
	GR_WM_PROPERTIES	wmprops;

	/* create window with no borders*/
	wid = GrNewWindow(parent, x, y, width, height, 0, background, BLACK);
	if (wid) {
		/* check for application decoration style*/
		if ((props & GR_WM_PROPS_APPMASK) == GR_WM_PROPS_APPWINDOW) {
			/* set default decoration style*/
			newprops = (props & ~GR_WM_PROPS_APPMASK) |
				GR_WM_PROPS_APPFRAME | GR_WM_PROPS_CAPTION |
				GR_WM_PROPS_CLOSEBOX;

		} else
			newprops = props;

		/* set properties and title*/
		wmprops.flags = GR_WM_FLAGS_PROPS | GR_WM_FLAGS_TITLE;
		wmprops.props = newprops;
		wmprops.title = title;
		GrSetWMProperties(wid, &wmprops);
	}
	return wid;
}
